Subject: Re: [PATCH][net-next] bridge: increase mtu to 9000

From: Stephen Hemminger <[email-masked]>
Date: Mon, 22 Feb 2016 09:58:08 -0800

On Mon, 22 Feb 2016 17:29:11 +0800
[email-masked] wrote:

> From: Li RongQing <[email-masked]>
> 
> A linux bridge always adopts the smallest MTU of the enslaved devices.
> When no device are enslaved, it defaults to a MTU of 1500 and refuses to
> use a larger one. This is problematic when using bridges enslaving only
> virtual NICs (vnetX) like it's common with KVM guests.
> 
> Steps to reproduce the problem
> 
> 1) sudo ip link add br-test0 type bridge # create an empty bridge
> 2) sudo ip link set br-test0 mtu 9000 # attempt to set MTU > 1500
> 3) ip link show dev br-test0 # confirm MTU
> 
> Here, 2) returns "RTNETLINK answers: Invalid argument". One (cumbersome)
> way around this is:
> 
> 4) sudo modprobe dummy
> 5) sudo ip link set dummy0 mtu 9000 master br-test0
> 
> Then the bridge's MTU can be changed from anywhere to 9000.
> 
> This is especially annoying for the virtualization case because the
> KVM's tap driver will by default adopt the bridge's MTU on startup
> making it impossible (without the workaround) to use a large MTU on the
> guest VMs.
> 
> https://bugs.launchpad.net/ubuntu/+source/linux/+bug/1399064
> 
> Signed-off-by: Li RongQing <[email-masked]>

Your change works, but I agree with Hannes. Just allow up to 64 * 1024 like
loopback does.  And no need for a #define for that it is only in one place.